; Simple implementation of AES in x86 assembly v0.1
; by Dcoder, 20/04/2005
; Complies with FIPS-197 specification

.686p
.mmx
.xmm
.model	flat,stdcall

include tables.inc

FWD_RND MACRO X, Y

	add edi, 4*4
	
	mov eax, [edi]
	mov ebx, [Y]
	shr ebx, 22
	and ebx, 03FCh	
	xor eax, [FT0 + ebx]
	mov ecx, [Y + 1*4]
	shr ecx, 14
	and ecx, 03FCh	
	xor eax, [FT1 + ecx]
	mov edx, [Y + 2*4]
	shr edx, 6
	and edx, 03FCh	
	xor eax, [FT2 + edx]
	mov ebx, [Y + 3*4]	
	movzx ebx, bl
	add ebx, ebx
	add ebx, ebx	
	xor eax, [FT3 + ebx]
	mov [X], eax
	;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax, [edi + 1*4]
	mov ebx, [Y + 1*4]
	shr ebx, 22
	and ebx, 03FCh		
	xor eax, [FT0 + ebx]
	mov ecx, [Y + 2*4]
	shr ecx, 14
	and ecx, 03FCh	
	xor eax, [FT1 + ecx]
	mov edx, [Y + 3*4]
	shr edx, 6
	and edx, 03FCh	
	xor eax, [FT2 + edx]
	mov ebx, [Y]
	movzx ebx, bl
	add ebx, ebx
	add ebx, ebx	
	xor eax, [FT3 + ebx]	
	mov [X + 1*4], eax
	;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax, [edi + 2*4]
	mov ebx, [Y + 2*4]
	shr ebx, 22
	and ebx, 03FCh		
	xor eax, [FT0 + ebx]
	mov ecx, [Y + 3*4]
	shr ecx, 14
	and ecx, 03FCh	
	xor eax, [FT1 + ecx]
	mov edx, [Y]
	shr edx, 6
	and edx, 03FCh	
	xor eax, [FT2 + edx]
	mov ebx, [Y + 1*4]
	movzx ebx, bl
	add ebx, ebx
	add ebx, ebx		
	xor eax, [FT3 + ebx]
	mov [X + 2*4], eax
	;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax, [edi + 3*4]
	mov ebx, [Y + 3*4]
	shr ebx, 22
	and ebx, 03FCh		
	xor eax, [FT0 + ebx]
	mov ecx, [Y]
	shr ecx, 14
	and ecx, 03FCh	
	xor eax, [FT1 + ecx]
	mov edx, [Y + 1*4]
	shr edx, 6
	and edx, 03FCh	
	xor eax, [FT2 + edx]
	mov ebx, [Y + 2*4]
	movzx ebx, bl
	add ebx, ebx
	add ebx, ebx	
	xor eax, [FT3 + ebx]
	mov [X + 3*4], eax	

ENDM

FWD_RNDL MACRO X, Y

	add edi, 4*4
	
	mov eax, [edi]
	mov ebx, [Y]
	shr ebx, 24
	movzx ebx, byte ptr [FSb + ebx]
	shl ebx, 24
	xor eax, ebx
	mov ecx, [Y + 1*4]
	shr ecx, 16
	movzx ecx, cl
	movzx ecx, byte ptr [FSb + ecx]
	shl ecx, 16
	xor eax, ecx
	mov edx, [Y + 2*4]
	shr edx, 8
	movzx edx, dl
	movzx edx, byte ptr [FSb + edx]
	shl edx, 8
	xor eax, edx
	mov ebx, [Y + 3*4]	
	movzx ebx, bl
	movzx ebx, byte ptr [FSb + ebx]
	xor eax, ebx
	mov [X], eax
	;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax, [edi + 1*4]
	mov ebx, [Y + 1*4]
	shr ebx, 24	
	movzx ebx, byte ptr [FSb + ebx]
	shl ebx, 24
	xor eax, ebx
	mov ecx, [Y + 2*4]
	shr ecx, 16
	movzx ecx, cl
	movzx ecx, byte ptr [FSb + ecx]
	shl ecx, 16
	xor eax, ecx
	mov edx, [Y + 3*4]
	shr edx, 8
	movzx edx, dl
	movzx edx, byte ptr [FSb + edx]
	shl edx, 8
	xor eax, edx
	mov ebx, [Y]
	movzx ebx, bl
	movzx ebx, byte ptr [FSb + ebx]
	xor eax, ebx
	mov [X + 1*4], eax
	;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax, [edi + 2*4]
	mov ebx, [Y + 2*4]
	shr ebx, 24
	movzx ebx, byte ptr [FSb + ebx]
	shl ebx, 24
	xor eax, ebx
	mov ecx, [Y + 3*4]
	shr ecx, 16
	movzx ecx, cl
	movzx ecx, byte ptr [FSb + ecx]
	shl ecx, 16
	xor eax, ecx
	mov edx, [Y]
	shr edx, 8
	movzx edx, dl
	movzx edx, byte ptr [FSb + edx]
	shl edx, 8
	xor eax, edx
	mov ebx, [Y + 1*4]
	movzx ebx, bl
	movzx ebx, byte ptr [FSb + ebx]
	xor eax, ebx
	mov [X + 2*4], eax
	;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax, [edi + 3*4]
	mov ebx, [Y + 3*4]
	shr ebx, 24
	movzx ebx, byte ptr [FSb + ebx]
	shl ebx, 24
	xor eax, ebx
	mov ecx, [Y]
	shr ecx, 16
	movzx ecx, cl
	movzx ecx, byte ptr [FSb + ecx]
	shl ecx, 16
	xor eax, ecx
	mov edx, [Y + 1*4]
	shr edx, 8
	movzx edx, dl
	movzx edx, byte ptr [FSb + edx]
	shl edx, 8
	xor eax, edx
	mov ebx, [Y + 2*4]
	movzx ebx, bl
	movzx ebx, byte ptr [FSb + ebx]
	xor eax, ebx
	mov [X + 3*4], eax	

ENDM

DLOOP MACRO

	mov ebp, [esi]
	mov ebx, ebp
	shr ebx, 22
	and ebx, 03FCh	
	mov ebx, [KT0 + ebx]
	mov ecx, ebp
	shr ecx, 14
	and ecx, 03FCh		
	xor ebx, [KT1 + ecx]
	mov edx, ebp
	shr edx, 6
	and edx, 03FCh		
	xor ebx, [KT2 + edx]
	and ebp, 0FFh
	add ebp, ebp
	add ebp, ebp	
	xor ebx, [KT3 + ebp]
	mov [edi], ebx
	add edi, 4
	add esi, 4

ENDM

INV_RND MACRO X, Y

	add edi, 4*4
	
	mov eax, [edi]
	mov ebx, [Y]
	shr ebx, 22
	and ebx, 03FCh	
	xor eax, [RT0 + ebx]
	mov ecx, [Y + 3*4]
	shr ecx, 14
	and ecx, 03FCh	
	xor eax, [RT1 + ecx]
	mov edx, [Y + 2*4]
	shr edx, 6
	and edx, 03FCh	
	xor eax, [RT2 + edx]
	mov ebx, [Y + 1*4]	
	movzx ebx, bl
	add ebx, ebx
	add ebx, ebx	
	xor eax, [RT3 + ebx]
	mov [X], eax
	;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax, [edi + 1*4]
	mov ebx, [Y + 1*4]
	shr ebx, 22
	and ebx, 03FCh		
	xor eax, [RT0 + ebx]
	mov ecx, [Y + 0*4]
	shr ecx, 14
	and ecx, 03FCh	
	xor eax, [RT1 + ecx]
	mov edx, [Y + 3*4]
	shr edx, 6
	and edx, 03FCh	
	xor eax, [RT2 + edx]
	mov ebx, [Y + 2*4]
	movzx ebx, bl
	add ebx, ebx
	add ebx, ebx		
	xor eax, [RT3 + ebx]
	mov [X + 1*4], eax
	;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax, [edi + 2*4]
	mov ebx, [Y + 2*4]
	shr ebx, 22
	and ebx, 03FCh		
	xor eax, [RT0 + ebx]
	mov ecx, [Y + 1*4]
	shr ecx, 14
	and ecx, 03FCh	
	xor eax, [RT1 + ecx]
	mov edx, [Y]
	shr edx, 6
	and edx, 03FCh	
	xor eax, [RT2 + edx]
	mov ebx, [Y + 3*4]
	movzx ebx, bl
	add ebx, ebx
	add ebx, ebx	
	xor eax, [RT3 + ebx]	
	mov [X + 2*4], eax
	;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax, [edi + 3*4]
	mov ebx, [Y + 3*4]
	shr ebx, 22
	and ebx, 03FCh	
	xor eax, [RT0 + ebx]
	mov ecx, [Y + 2*4]
	shr ecx, 14
	and ecx, 03FCh	
	xor eax, [RT1 + ecx]
	mov edx, [Y + 1*4]
	shr edx, 6
	and edx, 03FCh	
	xor eax, [RT2 + edx]
	mov ebx, [Y + 0*4]
	movzx ebx, bl
	add ebx, ebx
	add ebx, ebx	
	xor eax, [RT3 + ebx]
	mov [X + 3*4], eax	
ENDM

INV_RNDL MACRO X, Y

	add edi, 4*4
	
	mov eax, [edi]
	mov ebx, [Y + 0*4]
	shr ebx, 24
	movzx ebx, byte ptr [RSb + ebx]
	shl ebx, 24
	xor eax, ebx
	mov ecx, [Y + 3*4]
	shr ecx, 16
	movzx ecx, cl
	movzx ecx, byte ptr [RSb + ecx]
	shl ecx, 16
	xor eax, ecx
	mov edx, [Y + 2*4]
	shr edx, 8
	movzx edx, dl
	movzx edx, byte ptr [RSb + edx]
	shl edx, 8
	xor eax, edx
	mov ebx, [Y + 1*4]	
	movzx ebx, bl
	movzx ebx, byte ptr [RSb + ebx]
	xor eax, ebx
	mov [X], eax
	;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax, [edi + 1*4]
	mov ebx, [Y + 1*4]
	shr ebx, 24	
	movzx ebx, byte ptr [RSb + ebx]
	shl ebx, 24
	xor eax, ebx
	mov ecx, [Y + 0*4]
	shr ecx, 16
	movzx ecx, cl
	movzx ecx, byte ptr [RSb + ecx]
	shl ecx, 16
	xor eax, ecx
	mov edx, [Y + 3*4]
	shr edx, 8
	movzx edx, dl
	movzx edx, byte ptr [RSb + edx]
	shl edx, 8
	xor eax, edx
	mov ebx, [Y + 2*4]
	movzx ebx, bl
	movzx ebx, byte ptr [RSb + ebx]
	xor eax, ebx
	mov [X + 1*4], eax
	;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax, [edi + 2*4]
	mov ebx, [Y + 2*4]
	shr ebx, 24
	movzx ebx, byte ptr [RSb + ebx]
	shl ebx, 24
	xor eax, ebx
	mov ecx, [Y + 1*4]
	shr ecx, 16
	movzx ecx, cl
	movzx ecx, byte ptr [RSb + ecx]
	shl ecx, 16
	xor eax, ecx
	mov edx, [Y]
	shr edx, 8
	movzx edx, dl
	movzx edx, byte ptr [RSb + edx]
	shl edx, 8
	xor eax, edx
	mov ebx, [Y + 3*4]
	movzx ebx, bl
	movzx ebx, byte ptr [RSb + ebx]
	xor eax, ebx
	mov [X + 2*4], eax
	;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov eax, [edi + 3*4]
	mov ebx, [Y + 3*4]
	shr ebx, 24
	movzx ebx, byte ptr [RSb + ebx]
	shl ebx, 24
	xor eax, ebx
	mov ecx, [Y + 2*4]
	shr ecx, 16
	movzx ecx, cl
	movzx ecx, byte ptr [RSb + ecx]
	shl ecx, 16
	xor eax, ecx
	mov edx, [Y + 1*4]
	shr edx, 8
	movzx edx, dl
	movzx edx, byte ptr [RSb + edx]
	shl edx, 8
	xor eax, edx
	mov ebx, [Y + 0*4]
	movzx ebx, bl
	movzx ebx, byte ptr [RSb + ebx]
	xor eax, ebx
	mov [X + 3*4], eax	

ENDM

.data

	align 16
	X dd 4 dup(?)
	Y dd 4 dup(?)
	
.code

Set_Key proc aes_ctx:DWORD, key:DWORD, nbits:DWORD

	mov eax, nbits
	mov ebx, 10
	mov ecx, 12
	mov edx, 14	
	test eax, 100h
	cmovnz ebx, edx
	cmp eax, 0C0h
	cmovz ebx, ecx ; it doesn't complain if you don't pick the right bit number. So be careful.

	mov edx, aes_ctx
	mov dword ptr [edx + 512], ebx 

	mov esi, key	
	shr eax, 5  
_getint:
	mov ebx, dword ptr [esi]
	mov edi, dword ptr [esi + 4]
	bswap ebx	
	bswap edi
	mov dword ptr [edx], ebx
	mov dword ptr [edx + 4], edi
	mov ecx, dword ptr [esi + 8]
	mov ebx, dword ptr [esi + 12]
	bswap ecx	
	bswap ebx
	cmp eax, 4
	mov dword ptr [edx + 8], ecx
	mov dword ptr [edx + 12], ebx	
	je _getout
	mov edi, dword ptr [esi + 16]
	mov ecx, dword ptr [esi + 20]
	bswap edi	
	bswap ecx
	cmp eax, 6
	mov dword ptr [edx + 16], edi
	mov dword ptr [edx + 20], ecx
	je _getout
	mov ecx, dword ptr [esi + 24]
	mov ebx, dword ptr [esi + 28]
	bswap ecx	
	bswap ebx
	mov dword ptr [edx + 24], ecx
	mov dword ptr [edx + 28], ebx	
_getout:
	
	cmp eax, 4
	jnz _try192
	xor ecx, ecx 
_128loop:
	mov ebx, [edx]
	xor ebx, [RCON + ecx]
	mov esi, [edx + 3*4]	
	mov edi, esi
	shr edi, 16
	and edi, 0FFh
	movzx edi, byte ptr [FSb + edi]	
	shl edi, 24
	xor ebx, edi
	mov edi, esi
	shr edi, 8
	and edi, 0FFh
	movzx edi, byte ptr [FSb + edi]	
	shl edi, 16
	xor ebx, edi
	mov edi, esi
	and edi, 0FFh
	movzx edi, byte ptr [FSb + edi]	
	shl edi, 8
	xor ebx, edi
	mov edi, esi
	shr edi, 24
	movzx edi, byte ptr [FSb + edi]	
	xor ebx, edi		
	mov [edx + 4*4], ebx
	
	mov esi, [edx + 1*4]
	xor esi, [edx + 4*4]
	mov [edx + 5*4], esi
	mov edi, [edx + 2*4]
	xor edi, [edx + 5*4]
	mov [edx + 6*4], edi
	mov ebx, [edx + 3*4]
	xor ebx, [edx + 6*4]
	mov [edx + 7*4], ebx
	add edx, 4*4
	add ecx, 4
	cmp ecx, 10*4
	jb _128loop
	xor eax, eax
	ret
	

_try192:
	cmp eax, 6
	jnz _try256
	xor ecx, ecx
_192loop:
	mov ebx, [edx]
	xor ebx, [RCON + ecx]
	mov esi, [edx + 5*4]
	mov eax, esi
	shr eax, 16
	movzx eax, al
	movzx eax, byte ptr [FSb + eax]
	shl eax, 24
	xor ebx, eax
	mov eax, esi
	shr eax, 8
	movzx eax, al
	movzx eax, byte ptr [FSb + eax]
	shl eax, 16
	xor ebx, eax
	mov eax, esi
	movzx eax, al
	movzx eax, byte ptr [FSb + eax]
	shl eax, 8
	xor ebx, eax
	mov eax, esi
	shr eax, 24
	movzx eax, byte ptr [FSb + eax]
	xor ebx, eax
	mov [edx + 6*4], ebx

	mov eax, [edx + 1*4]
	xor eax, [edx + 6*4]
	mov [edx + 7*4], eax
	mov eax, [edx + 2*4]
	xor eax, [edx + 7*4]
	mov [edx + 8*4], eax
	mov ebx, [edx + 3*4]
	xor ebx, [edx + 8*4]
	mov [edx + 9*4], ebx
	mov eax, [edx + 4*4]
	xor eax, [edx + 9*4]
	mov [edx + 10*4], eax
	mov eax, [edx + 5*4]
	xor eax, [edx + 10*4]
	mov [edx + 11*4], eax
	add edx, 6*4
	add ecx, 4
	cmp ecx, 8*4
	jb _192loop
	xor eax, eax
	ret
	

_try256:
	xor ecx, ecx
_256loop:
	mov ebx, [edx]
	xor ebx, [RCON + ecx]
	mov esi, [edx + 7*4]
	mov eax, esi
	shr eax, 16
	movzx eax, al
	movzx eax, byte ptr [FSb + eax]
	shl eax, 24
	xor ebx, eax
	mov eax, esi
	shr eax, 8
	movzx eax, al
	movzx eax, byte ptr [FSb + eax]
	shl eax, 16
	xor ebx, eax
	mov eax, esi
	movzx eax, al
	movzx eax, byte ptr [FSb + eax]
	shl eax, 8
	xor ebx, eax
	mov eax, esi
	shr eax, 24
	movzx eax, byte ptr [FSb + eax]
	xor ebx, eax
	mov [edx + 8*4], ebx

	mov eax, [edx + 1*4]
	xor eax, [edx + 8*4]
	mov [edx + 9*4], eax
	mov ebx, [edx + 2*4]
	xor ebx, [edx + 9*4]
	mov [edx + 10*4], ebx
	mov eax, [edx + 3*4]
	xor eax, [edx + 10*4]
	mov [edx + 11*4], eax

	mov ebx, [edx + 4*4]
	mov esi, [edx + 11*4]
	mov eax, esi	
	shr eax, 24	
	movzx eax, byte ptr [FSb + eax]
	shl eax, 24
	xor ebx, eax
	mov eax, esi
	shr eax, 16
	movzx eax, al
	movzx eax, byte ptr [FSb + eax]
	shl eax, 16
	xor ebx, eax
	mov eax, esi	
	shr eax, 8
	movzx eax, al
	movzx eax, byte ptr [FSb + eax]
	shl eax, 8
	xor ebx, eax
	mov eax, esi
	movzx eax, al
	movzx eax, byte ptr [FSb + eax]
	xor ebx, eax
	mov [edx + 12*4], ebx

	mov eax, [edx + 5*4]
	xor eax, [edx + 12*4]
	mov [edx + 13*4], eax
	mov ebx, [edx + 6*4]
	xor ebx, [edx + 13*4]
	mov [edx + 14*4], ebx
	mov eax, [edx + 7*4]
	xor eax, [edx + 14*4]
	mov [edx + 15*4], eax
	add edx, 8*4
	add ecx, 4
	cmp ecx, 7*4
	jb _256loop
	xor eax, eax
	ret

Set_Key endp

Encrypt proc aes_ctx:DWORD, input:DWORD, output:DWORD

	mov edi, aes_ctx
	mov esi, input

	mov ebx, [esi]	
	mov ecx, [esi + 4]
	mov eax, [esi + 8]	
	mov edx, [esi + 12]	
	bswap ebx
	bswap eax
	bswap edx	
	bswap ecx	
	xor ebx, [edi]
	xor ecx, [edi + 4]
	xor eax, [edi + 8]
	xor edx, [edi + 12]
	mov [X], ebx
	mov [X + 4], ecx
	mov [X + 8], eax
	mov [X + 12], edx

	push ebp
	push aes_ctx
	mov esi, offset X
	mov ebp, offset Y

	FWD_RND ebp, esi ; round1
	FWD_RND esi, ebp ; round2
	FWD_RND ebp, esi ; round3
	FWD_RND esi, ebp ; round4
	FWD_RND ebp, esi ; round5
	FWD_RND esi, ebp ; round6
	FWD_RND ebp, esi ; round7
	FWD_RND esi, ebp ; round8
	FWD_RND ebp, esi ; round9

	pop eax	
	cmp dword ptr [eax + 512], 10
	jbe _lastround
	push eax

	FWD_RND esi, ebp ; round10
	FWD_RND ebp, esi ; round11

	pop eax
	cmp dword ptr [eax + 512], 12
	jbe _lastround

	FWD_RND esi, ebp ; round12
	FWD_RND ebp, esi ; round13

_lastround:

	FWD_RNDL esi, ebp ; last round.

	pop ebp

	mov edi, output
	mov eax, [esi]
	mov ebx, [esi + 4]	
	mov ecx, [esi + 8]
	mov edx, [esi + 12]
	bswap ebx	
	bswap ecx
	bswap eax
	bswap edx
	mov [edi], eax
	mov [edi + 4], ebx
	mov [edi + 8], ecx
	mov [edi + 12], edx
	
	ret

Encrypt endp 

SetD_Key proc aes_ctx:DWORD, key:DWORD, nbits:DWORD

	invoke Set_Key, aes_ctx, key, nbits
	
	mov eax, aes_ctx
	mov esi, [eax + 512]
	shl esi, 4
	lea esi, [eax + esi]
	lea edi, [eax + 256]

	push ebp

	;movdqa XMM0, [esi]
	;movdqa [edi], XMM0
	mov ebp, [esi]
	mov [edi], ebp
	mov ebp, [esi + 4]
	mov [edi + 4], ebp
	mov ebp, [esi + 8]
	mov [edi + 8], ebp
	mov ebp, [esi + 12]
	mov [edi + 12], ebp

	mov eax, [eax + 512]
	sub eax, 1
	add esi, 16
	add edi, 16
	
_dloop:
	sub esi, 8*4
	
	DLOOP
	DLOOP
	DLOOP
	DLOOP

	sub eax, 1
	jnz _dloop
	
	sub esi, 8*4
	
	;movdqa XMM0, [esi]
	;movdqa [edi], XMM0

	mov ebp, [esi]
	mov [edi], ebp
	mov ebp, [esi + 4]
	mov [edi + 4], ebp
	mov ebp, [esi + 8]
	mov [edi + 8], ebp
	mov ebp, [esi + 12]
	mov [edi + 12], ebp
	
	xor eax, eax
	pop ebp
	ret

SetD_key endp

Decrypt proc aes_ctx:DWORD, input:DWORD, output:DWORD
	
	mov edi, [aes_ctx]
	lea edi, [edi + 256]
	mov esi, input

	mov ebx, [esi]	
	mov ecx, [esi + 4]
	mov eax, [esi + 8]	
	mov edx, [esi + 12]	
	bswap ebx
	bswap ecx
	bswap eax
	bswap edx
	xor ebx, [edi]
	xor ecx, [edi + 4]
	xor eax, [edi + 8]
	xor edx, [edi + 12]
	mov [X], ebx
	mov [X + 4], ecx
	mov [X + 8], eax
	mov [X + 12], edx

	push ebp
	push aes_ctx
	mov esi, offset X
	mov ebp, offset Y

	INV_RND ebp, esi ; round1
	INV_RND esi, ebp ; round2
	INV_RND ebp, esi ; round3
	INV_RND esi, ebp ; round4
	INV_RND ebp, esi ; round5
	INV_RND esi, ebp ; round6
	INV_RND ebp, esi ; round7
	INV_RND esi, ebp ; round8
	INV_RND ebp, esi ; round9

	pop eax
	cmp dword ptr [eax + 512], 10	
	jbe last
	push eax

	INV_RND esi, ebp ; round10
	INV_RND ebp, esi ; round11

	pop eax
	cmp dword ptr [eax + 512], 12
	jbe last
	
	INV_RND esi, ebp ; round12
	INV_RND ebp, esi ; round13
last:
	
	INV_RNDL esi, ebp ; last round.
	pop ebp

	mov edi, output
	mov eax, [esi]
	mov ebx, [esi + 4]	
	mov ecx, [esi + 8]
	mov edx, [esi + 12]
	bswap ebx	
	bswap ecx
	bswap eax
	bswap edx
	mov [edi], eax
	mov [edi + 4], ebx
	mov [edi + 8], ecx
	mov [edi + 12], edx
	
	ret

Decrypt endp

END